unit principale; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, db, dbf,
  DBGrids, ExtCtrls, rxappicon, rxctrls, Menus, LR_Class, PrintersDlgs, Buttons,
  StdCtrls, LazJPEG, ins_mod, info, DbCtrls, Process, Printers, LR_DBSet,
  ovclabel;

type

  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    BitVisMod: TBitBtn;
    BitStaSched: TBitBtn;
    Datasource1: TDatasource;
    Datasource2: TDatasource;
    DBEdit1: TDBEdit;
    DBEdit10: TDBEdit;
    DBEdit11: TDBEdit;
    DBEdit12: TDBEdit;
    DBEdit13: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    Dbf1: TDbf;
    Dbf2: TDbf;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    frDB1: TfrDBDataSet;
    Image2: TImage;
    OvcLabel1: TOvcLabel;
    Ric_nome: TMenuItem;
    Ric_cognome: TMenuItem;
    Ord_codice: TMenuItem;
    Ord_citta: TMenuItem;
    Ord_nome: TMenuItem;
    Ord_cognome: TMenuItem;
    St_scheda: TMenuItem;
    Sta_elenco: TMenuItem;
    Sta_busta: TMenuItem;
    Report1: TfrReport;
    IdleTimer1: TIdleTimer;
    Image1: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuChiudi: TMenuItem;
    MenuItem1: TMenuItem;
    MenuAiuto: TMenuItem;
    MenuInfo: TMenuItem;
    MenuRsci: TMenuItem;
    MenuSalvacn: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuNuovo: TMenuItem;
    MenuApri: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    PrintDialog1: TPrintDialog;
    RxAppIcon1: TRxAppIcon;
    RxLabel2: TRxLabel;
    SaveDialog1: TSaveDialog;
    SpButtonAvanti: TSpeedButton;
    SpButtonIndietro: TSpeedButton;
    SpButtonPrimo: TSpeedButton;
    SpButtonUltimo: TSpeedButton;
    SpButtonAgg: TSpeedButton;
    SpButtonCanc: TSpeedButton;
    SpButtonEsci: TSpeedButton;
    Speedmail: TSpeedButton;
    Speedweb: TSpeedButton;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    procedure BitStaSchedClick(Sender: TObject);
    procedure BitVisModClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure IdleTimer1Timer(Sender: TObject);
    procedure MenuAiutoClick(Sender: TObject);
    procedure MenuApriClick(Sender: TObject);
    procedure MenuChiudiClick(Sender: TObject);
    procedure MenuInfoClick(Sender: TObject);
    procedure MenuNuovoClick(Sender: TObject);
    procedure MenuRsciClick(Sender: TObject);
    procedure MenuSalvacnClick(Sender: TObject);
    procedure Ord_cittaClick(Sender: TObject);
    procedure Ord_codiceClick(Sender: TObject);
    procedure Ord_cognomeClick(Sender: TObject);
    procedure Ord_nomeClick(Sender: TObject);
    procedure Ric_cognomeClick(Sender: TObject);
    procedure Ric_nomeClick(Sender: TObject);
    procedure SpButtonAggClick(Sender: TObject);
    procedure SpButtonAvantiClick(Sender: TObject);
    procedure SpButtonCancClick(Sender: TObject);
    procedure SpButtonEsciClick(Sender: TObject);
    procedure SpButtonIndietroClick(Sender: TObject);
    procedure SpButtonPrimoClick(Sender: TObject);
    procedure SpButtonUltimoClick(Sender: TObject);
    procedure SpeedmailClick(Sender: TObject);
    procedure SpeedwebClick(Sender: TObject);
    procedure St_schedaClick(Sender: TObject);
    procedure Sta_bustaClick(Sender: TObject);
    procedure Sta_elencoClick(Sender: TObject);
    procedure leggivalori;
    procedure Inserisci;
    procedure StampaBusta;
    
  private
    { private declarations }
    procedure Apritabella(nometabella:string);
    procedure Creatabella(nometabella:string);
    Procedure Salvaconnome(nometabella:string);
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  var cerca,cognom, percors, formadata: string;

implementation

{ TForm1 }

//////////////////////////////////////Creatabella
procedure TForm1.Creatabella(nometabella:string);
begin
with dbf1 do
begin
tablelevel:=4;
close;
with fielddefs do
begin
clear;
add('ID', ftstring,5,true);
add('TITOLO',ftstring,12);
add('COGNOME',ftstring,35,true);
add('NOME', ftstring,35);
add('INDIRIZZO',ftstring,50);
add('CAP',ftstring,5);
add('CITTA',ftstring,30);
add('PROV',ftstring,4);
add('STATO',ftstring,18);
add('NUMTEL',ftstring,16);
add('NUMCELL',ftstring,16);
add('NUMFAX',ftstring,16);
add('INDEMAIL',ftstring,50);
add('INDWEB',ftstring,50);
add('NOTE',ftmemo,0);
add('DATANASC',ftdate,0);
add('PROFESSION',ftstring,30);
end;
tablename:=extractfilename(nometabella);
filepathfull:=extractfilepath(nometabella);
exclusive:=true;
createtable;
open;
addindex('codice', 'ID', [ixprimary,ixUnique]);
addindex('cognom', 'COGNOME', [ixcaseinsensitive]);
addindex('nom', 'NOME', [ixcaseinsensitive]);
addindex('citt', 'CITTA', [ixcaseinsensitive]);
close;           label3.Caption:=formatdatetime('hh:nn:ss',time);
  RXlabel2.Caption:=datetostr(date);
end;
showmessage('Creato il nuovo file : '+nometabella);
end;

////////////////////Apritabella
procedure TForm1.Apritabella(nometabella:string);
var percorso:string;
begin
dbf1.tablename:=extractfilename(nometabella);
percorso:=extractfilepath(nometabella);
dbf1.filepathfull:=percorso;
dbf1.filepath:=percorso;
label2.Caption:=extractfilename(nometabella);
dbf1.exclusive:=true;
dbf1.open;
dbf1.IndexFieldNames:='COGNOME';
label1.Caption:=inttostr(dbf1.ExactRecordCount);
end;

//////////////////////////////////////leggivalori
procedure Tform1.leggivalori;
begin
  form2.Edit1.Text:=form1.Dbf1.FieldByName('ID').AsString;
  form2.Edit2.Text:=form1.Dbf1.FieldByName('TITOLO').AsString;
  form2.edit3.Text:=form1.Dbf1.FieldByName('COGNOME').AsString;
  form2.edit4.Text:=form1.Dbf1.FieldByName('NOME').AsString;
  form2.edit5.Text:=form1.Dbf1.FieldByName('INDIRIZZO').AsString;
  form2.edit6.Text:=form1.Dbf1.FieldByName('CAP').AsString;
  form2.edit7.Text:=form1.Dbf1.FieldByName('CITTA').AsString;
  form2.edit8.Text:=form1.Dbf1.FieldByName('PROV').AsString;
  form2.edit9.Text:=form1.Dbf1.FieldByName('STATO').AsString;
  form2.edit10.Text:=form1.Dbf1.FieldByName('NUMTEL').AsString;
  form2.edit11.Text:=form1.Dbf1.FieldByName('NUMCELL').AsString;
  form2.edit12.Text:=form1.Dbf1.FieldByName('NUMFAX').AsString;
  form2.edit13.Text:=form1.Dbf1.FieldByName('INDEMAIL').AsString;
  form2.edit14.Text:=form1.Dbf1.FieldByName('INDWEB').AsString;
  form2.edit15.Text:=formatdatetime('dd/mm/YYYY',form1.Dbf1.FieldByName('DATANASC').Asdatetime);
  form2.edit16.Text:=form1.Dbf1.FieldByName('PROFESSION').AsString;
  form2.memo1.Text:=form1.Dbf1.FieldByName('NOTE').AsString;
end;

//////////////////////////////////////Salvaconnome
procedure TForm1.Salvaconnome(nometabella:string);
begin
with dbf2 do begin
tablelevel:=4;
close;
with fielddefs do begin
clear;
add('ID', ftstring,5,true);
add('TITOLO',ftstring,12);
add('COGNOME',ftstring,35,true);
add('NOME', ftstring,35);
add('INDIRIZZO',ftstring,50);
add('CAP',ftstring,5);
add('CITTA',ftstring,30);
add('PROV',ftstring,4);
add('STATO',ftstring,18);
add('NUMTEL',ftstring,16);
add('NUMCELL',ftstring,16);
add('NUMFAX',ftstring,16);
add('INDEMAIL',ftstring,50);
add('INDWEB',ftstring,50);
add('NOTE',ftmemo,0);
add('DATANASC',ftdate,0);
add('PROFESSION',ftstring,30);
end;
tablename:=extractfilename(nometabella);
filepathfull:=percors;
createtable;
exclusive:=true;
open;
addindex('codice', 'ID', [ixprimary,ixUnique]);
addindex('cognom', 'COGNOME', [ixcaseinsensitive]);
addindex('nom', 'NOME', [ixcaseinsensitive]);
addindex('citt', 'CITTA', [ixcaseinsensitive]);
close
end;
////////////copia
dbf2.Open;
dbf1.First;
while not dbf1.EOF do begin
dbf2.Append;
Dbf2.FieldByName('ID').AsString:=Dbf1.FieldByName('ID').AsString;
Dbf2.FieldByName('TITOLO').AsString:=Dbf1.FieldByName('TITOLO').AsString;
Dbf2.FieldByName('COGNOME').AsString:=Dbf1.FieldByName('COGNOME').AsString;
Dbf2.FieldByName('NOME').AsString:=Dbf1.FieldByName('NOME').AsString;
Dbf2.FieldByName('INDIRIZZO').AsString:=Dbf1.FieldByName('INDIRIZZO').AsString;
Dbf2.FieldByName('CAP').AsString:=Dbf1.FieldByName('CAP').AsString;
Dbf2.FieldByName('CITTA').AsString:=Dbf1.FieldByName('CITTA').AsString;
Dbf2.FieldByName('PROV').AsString:=Dbf1.FieldByName('PROV').AsString;
Dbf2.FieldByName('STATO').AsString:=Dbf1.FieldByName('STATO').AsString;
Dbf2.FieldByName('NUMTEL').AsString:=Dbf1.FieldByName('NUMTEL').AsString;
Dbf2.FieldByName('NUMCELL').AsString:=Dbf1.FieldByName('NUMCELL').AsString;
Dbf2.FieldByName('NUMFAX').AsString:=Dbf1.FieldByName('NUMFAX').AsString;
Dbf2.FieldByName('INDEMAIL').AsString:=Dbf1.FieldByName('INDEMAIL').AsString;
Dbf2.FieldByName('INDWEB').AsString:=Dbf1.FieldByName('INDWEB').AsString;
Dbf2.FieldByName('NOTE').AsString:=Dbf1.FieldByName('NOTE').AsString;
Dbf2.FieldByName('DATANASC').Asdatetime:=Dbf1.FieldByName('DATANASC').Asdatetime;
Dbf2.FieldByName('PROFESSION').AsString:=Dbf1.FieldByName('PROFESSION').AsString;
dbf2.Post;
dbf1.Next;
end;
dbf2.close;
dbf1.Close;
dbf1.tablename:=dbf2.TableName;
  dbf1.filepath:=extractfilepath(nometabella);
  dbf1.exclusive:=true;
  dbf1.open;
  dbf1.IndexName:='cognom';
  label2.Caption:=dbf1.TableName;
dbf2.tablename:='';
dbf2.filepath:='';
showmessage('Creato nuovo file : '+nometabella);
end;

//////////////////////////////////////Inserisci
procedure Tform1.Inserisci;
begin
if dbf1.active then begin
form2.show; form2.codice; end  else
showmessage('   Nessun file aperto       ');
end;

procedure TForm1.MenuRsciClick(Sender: TObject);
begin
  dbf1.Close;
  dbf2.Close;
  close
end;

procedure TForm1.MenuSalvacnClick(Sender: TObject);
begin
  if dbf1.active=false then begin
showmessage('   Nessun file aperto       ');exit end;
    if savedialog1.Execute then begin;
  if fileexists(savedialog1.FileName) then
begin showmessage('File esistente !'); exit end;
  percors:=extractfilepath(savedialog1.FileName);
  Salvaconnome(savedialog1.FileName);
  end;
end;

/////////////////////////////////// StampaBusta
procedure TForm1.StampaBusta;
begin
Report1.LoadFromFile(ExtractFilePath(ParamStr(0))+'busta.lrf');
  Report1.ShowReport
end;

procedure TForm1.Ord_cittaClick(Sender: TObject);
begin
  dbf1.IndexFieldNames:='CITTA';
end;

procedure TForm1.Ord_codiceClick(Sender: TObject);
begin
  dbf1.IndexFieldNames:='ID';
end;

procedure TForm1.Ord_cognomeClick(Sender: TObject);
begin
  dbf1.IndexFieldNames:='COGNOME';
end;

procedure TForm1.Ord_nomeClick(Sender: TObject);
begin
  dbf1.IndexFieldNames:='NOME';
end;

procedure TForm1.Ric_cognomeClick(Sender: TObject);
begin
  if dbf1.Active=false then exit;
  dbf1.IndexFieldNames:='COGNOME';
  dbf1.First;
  cerca:=inputbox('ricerca','immetti cognome','');
  if cerca='' then exit;
  if dbf1.Locate('COGNOME',cerca,[]) then exit
  else begin
  showmessage(' NON TROVATO. '); exit
  end;
end;

procedure TForm1.Ric_nomeClick(Sender: TObject);
begin
  if dbf1.Active=false then exit;
  dbf1.IndexFieldNames:='NOME';
  dbf1.First;
  cerca:=inputbox('ricerca','immetti nome','');
  if cerca='' then exit;
  if dbf1.Locate('NOME',cerca,[]) then exit
  else begin
  showmessage(' NON TROVATO. '); exit
  end;
end;

procedure TForm1.SpButtonAggClick(Sender: TObject);
begin
  form2.BitBtn2.Enabled:=true;
  form2.BitBtn3.Enabled:=false;
  dbf1.IndexFieldNames:='';
  inserisci
end;

procedure TForm1.SpButtonAvantiClick(Sender: TObject);
begin
  if dbf1.Active=false then exit;
  dbf1.Next;
end;

procedure TForm1.SpButtonCancClick(Sender: TObject);
begin
  if dbf1.Active then begin;
   if MessageDlg('ATTENZIONE','Sicuro di cancellare?',mtConfirmation,[mbYes,mbNo],0)= mrYes
   then dbf1.Delete;
   end
   else  showmessage('   Nessun file aperto       ');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RxAppIcon1.LoadFromFile(extractfilepath(Application.ExeName)+'rubri1.xpm');
  RxAppIcon1.ApplyIcon;
  idletimer1.Enabled:=true;
  label1.Caption:='0';
  label2.Caption:='Nessuno';
end;

procedure TForm1.BitVisModClick(Sender: TObject);
begin
  if not dbf1.Active then begin
  showmessage('      nessun file aperto !     ');exit end;
  form2.Show;
  leggivalori;
  form2.BitBtn2.Enabled:=false;
  form2.BitBtn3.Enabled:=true;
  form2.Edit2.SetFocus;
end;

procedure TForm1.DBGrid1DblClick(Sender: TObject);
begin
  if dbf1.Active=false then exit;
  form2.Show;
  leggivalori;
  form2.BitBtn2.Enabled:=false;
  form2.BitBtn3.Enabled:=true;
  form2.Edit2.SetFocus;
end;

procedure TForm1.BitStaSchedClick(Sender: TObject);
begin
  if not dbf1.Active then begin
  showmessage('      Nessun file aperto !     ');exit end;
  Report1.LoadFromFile(ExtractFilePath(ParamStr(0))+'rubri3.lrf');
  Report1.ShowReport;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  RXlabel2.Caption:=formatdatetime('dd/mm/YYYY',date);
  label3.Caption:=formatdatetime('hh:nn:ss',time);
end;

procedure TForm1.IdleTimer1Timer(Sender: TObject);
begin
  label3.Caption:=formatdatetime('hh:nn:ss',time);
end;

procedure TForm1.MenuAiutoClick(Sender: TObject);
var perc:string; Aproc:TProcess;
begin
  perc:=extractfilepath(application.ExeName)+'/help/help_rubrica.html';
  AProc:= TProcess.Create(nil);
  AProc.CommandLine:= 'firefox '+perc+'';
  AProc.Options:= AProc.Options + [poWaitOnExit];
  AProc.Execute;
  AProc.Free;
end;

procedure TForm1.MenuApriClick(Sender: TObject);
begin
  if dbf1.Active then dbf1.Close;
  if opendialog1.Execute then begin
  apritabella(opendialog1.FileName);
  dbf1.First end;
end;

procedure TForm1.MenuChiudiClick(Sender: TObject);
begin
  dbf1.Close;
  label2.Caption:='nessuno';
  label1.Caption:='0';
end;

procedure TForm1.MenuInfoClick(Sender: TObject);
begin
  form3.Show;
end;

procedure TForm1.MenuNuovoClick(Sender: TObject);
begin
  if savedialog1.Execute then begin;
  if fileexists(savedialog1.FileName) then
begin showmessage('File esistente !'); exit end;
  creatabella(savedialog1.FileName);
  end;
end;

procedure TForm1.SpButtonEsciClick(Sender: TObject);
begin
  dbf1.Close;
  dbf2.Close;
  close
end;

procedure TForm1.SpButtonIndietroClick(Sender: TObject);
begin
  if dbf1.Active=false then exit;
  dbf1.Prior;
end;

procedure TForm1.SpButtonPrimoClick(Sender: TObject);
begin
  if dbf1.Active=false then exit;
  dbf1.First;
end;

procedure TForm1.SpButtonUltimoClick(Sender: TObject);
begin
  if dbf1.Active=false then exit;
  dbf1.Last;
end;

procedure TForm1.SpeedmailClick(Sender: TObject);
var AProcess: TProcess;
begin
  if dbf1.Active=false then exit;
  if dbf1.FieldByName('INDEMAIL').AsString='' then exit;
  AProcess:= TProcess.Create(nil);
  AProcess.CommandLine:='thunderbird -compose to='+dbedit12.Text+',subject=email_da_rubrica,body=Salve';
  AProcess.Options:= AProcess.Options + [poWaitOnExit];
  AProcess.Execute;
  AProcess.Free;
end;

procedure TForm1.SpeedwebClick(Sender: TObject);
var AProcess: TProcess;
begin
  if dbf1.Active=false then exit;
  if dbf1.FieldByName('INDWEB').AsString='' then exit;
  AProcess:= TProcess.Create(nil);
  AProcess.CommandLine:= 'firefox '+dbedit13.Text+'';
  AProcess.Options:= AProcess.Options + [poWaitOnExit];
  AProcess.Execute;
  AProcess.Free;
end;

procedure TForm1.St_schedaClick(Sender: TObject);
begin
  if not dbf1.Active then begin
  Showmessage('     Nessun file aperto !     ');exit end;
  Report1.LoadFromFile(ExtractFilePath(ParamStr(0))+'rubri3.lrf');
  Report1.ShowReport
end;

procedure TForm1.Sta_bustaClick(Sender: TObject);
begin
  if not dbf1.Active then begin
  showmessage('      Nessun file aperto !     ');exit end;
  StampaBusta
end;

procedure TForm1.Sta_elencoClick(Sender: TObject);
begin
  if not dbf1.Active then begin
  Showmessage('     Nessun file aperto !     ');exit end;
  dbf1.DisableControls;
  report1.Dataset:=frdb1;
  Report1.LoadFromFile(ExtractFilePath(ParamStr(0))+'totale.lrf');
  Report1.ShowReport;
  dbf1.EnableControls;
end;

initialization
  {$I principale.lrs}

end.

